<?php
/**
 * 2007-2017 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * No redistribute in other sites, or copy.
 *
 * @author    smokestorm <demo@demo.com>
 * @copyright 2007-2019 smokestorm
 * added
 * @license   http://localhost
 */

require_once('resource.php');
require_once('clientresource.php');
require_once('suscribe.php');

class DopplerClient
{
    /**
     * Endpoint to doppler api
     * @var string
     */
    public $_url = 'http://api2.fromdoppler.com/Default.asmx?WSDL';
    /**
     * Resource Campaign
     * @var CampaignResource extends Resource
     */
    public $campaign;
    /**
     * User resource
     * @var ClientResource  extends Resource
     */
    public $user;
    /**
     * Field Resource
     * @var FieldResource extends Resource
     */
    public $field;
    /**
     * Subscriber Resource
     * @var FieldSource $subscriber
     */
    public $subscriber;
    /**
     *
     *
     *
     *
     * var $_soapClient;
     *
     * /**
     * Class constructor
     *
     * @param String
     */
    public function __construct($apiKey)
    {
        $this->_soapClient = new SoapClient('http://api2.fromdoppler.com/Default.asmx?WSDL');
        $this->_apiKey = $apiKey;

        $curlInit = curl_init('http://api2.fromdoppler.com');
        curl_setopt($curlInit, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curlInit, CURLOPT_HEADER, true);
        curl_setopt($curlInit, CURLOPT_NOBODY, true);
        curl_setopt($curlInit, CURLOPT_RETURNTRANSFER, true);

        //get answer
        $response = curl_exec($curlInit);

        curl_close($curlInit);
        if ($response) {
        } else {
            //echo 'Doppler service down. Try later';
            return false;
        }
        /*		$this->campaign = new CampaignResource(
                    $this,
                    array(
                        'functions' => array(
                            'getBouncesList' => array(
                                'methodApiName' => 'Campaign.GetBouncesList',
                                ),
                            'getHardBouncesList' => array(
                                'methodApiName' => 'Campaign.GetHardBouncesList'
                                ),
                            'getSoftBouncesList' => array(
                                'methodApiName' => 'Campaign.GetSoftBouncesList'
                                )
                            'getSubscribersListsByCampaign' => array(
                                'methodApiName' => 'Campaign.GetSubscribersLists'
                                ),
                            'getUnsubscribesList' => array(
                                'methodApiName' => 'Campaign.GetUnsubscribesList'
                                )
                            )
                        )
                    );*/

        $this->user = new ClientResource(
            $this,
            array(
                'functions' => array(
                    'addSubscriber' => array(
                        'methodApiName' => 'AddSubscriberwithName',
                    ),
                    'getCampaignsList' => array(
                        'methodApiName' => 'GetCampaignsList'
                    ),
                    'getLastSentCampaign ' => array(
                        'methodApiName' => 'GetLastSentCampaign'
                    ),
                    'getSubscribersLists' => array(
                        'methodApiName' => 'GetSubscribersLists'
                    ),
                    'testApiConnection' => array(
                        'methodApiName' => 'TestApiConnection'
                    )
                )
            )
        );

        $this->subscriber = new SubscriberResource(
            $this,
            array(
                'functions' => array(
                    'addSubscriber' => array(
                        'methodApiName' => 'AddSubscriberwithName',
                    )
                )
            )
        );
    }

    public function soapCall(
        $method,
        $args = null
    ) {

        $result = false;
        $retry_count = 0;
        $max_retry = 5;

        $apiKeyArgs = array('APIKey' => $this->_apiKey);

        $args = $args == null ? $apiKeyArgs : array_merge(
            $apiKeyArgs,
            $args
        );


        while (!$result && $retry_count < $max_retry) {
            try {
                $result = $this->_soapClient->$method($args);
                return $result;
            } catch (SoapFault $fault) {
                if ($fault->faultstring != 'Could not connect to host') {
                    throw $fault;
                }
            }
            sleep(1);
            $retry_count++;
        }
        if ($retry_count == $max_retry) {
            echo('Could not connect to host after 5 attempts');
        }
        return $result;
    }
}
