<?php
/**
 * 2007-2017 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * No redistribute in other sites, or copy.
 *
 * @author    smokestorm <demo@demo.com>
 * @copyright 2007-2017 smokestorm
 * added
 * @license   http://localhost
 */

class Dopplermail extends Module
{
    private $_html = '';
    private $_postErrors = array();
    public $available_fields = array();

    public function __construct()
    {
        include_once(dirname(__FILE__).'/class/dopplerpopupClass.php');
        require_once(dirname(__FILE__).'/class/client.php');
        $this->module_key = 'c7a30c0be439ec38072db7196d79d9c8';
        $this->name = 'dopplermail';
        if (_PS_VERSION_ < '1.4.0.0') {
            $this->tab = 'Blocks';
        }
        if (_PS_VERSION_ > '1.4.0.0') {
            $this->tab = 'administration';
            $this->author = 'doppler';
            $this->need_instance = 1;
        }
        if (_PS_VERSION_ > '1.6.0.0') {
            $this->bootstrap = true;
        }
        $this->version = '1.0.0';
        parent::__construct();
        $this->displayName = $this->l('Doppler');
        $this->description = $this->l('Doppler Email Marketing');
    }

    public function install()
    {
        if (!Configuration::updateValue(
            'DOPPLER_API',
            'TuApiDoppler'
        ) || !Configuration::updateValue(
            'DOPPLER_PROFILE',
            'xxxxxxxxxx'
        ) || !Configuration::updateValue(
            'DOPPLER_EVERYWHERE',
            0
        ) || !Configuration::updateValue(
            'DOPPLER_KEY',
            'xxx'
        ) || !Configuration::updateValue(
            'DOPPLER_PROFILE2',
            '1'
        ) || !Configuration::updateValue(
            'DOPPLER_KEY2',
            'xxx'
        ) || !Configuration::updateValue(
            'DOPPLER_BOX_WIDTH',
            700
        ) || !Configuration::updateValue(
            'DOPPLER_BOX_HEIGHT',
            394
        ) || !Configuration::updateValue(
            'DOPPLER_SHOW_TIME',
            3
        ) || !Configuration::updateValue(
            'DOPPLER_BTN_COLOR',
            "#BD1E30"
        ) || !Configuration::updateValue(
            'DOPPLER_TITLE_COLOR',
            "#FFFFFF"
        ) || !Configuration::updateValue(
            'DOPPLER_IMAGE_COVER',
            "dopplerpopup_img_1.jpg"
        ) || !Configuration::updateValue(
            'DOPPLER_EVERYWHERE',
            0
        ) || !parent::install() || !$this->registerHook('actionCustomerAccountAdd') || !$this->registerHook(
            'displayTop'
        ) || !$this->registerHook('displayHome') || !$this->registerHook('displayBeforeBodyClosingTag') || !$this->registerHook('displayHeader')
        ) {
            return false;
        }
        Db::getInstance()
          ->execute(
              '
		CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'newsletter` (
			`id` int(6) NOT NULL AUTO_INCREMENT,
			`id_shop` INTEGER UNSIGNED NOT NULL DEFAULT \'1\',
			`id_shop_group` INTEGER UNSIGNED NOT NULL DEFAULT \'1\',
			`email` varchar(255) NOT NULL,
			`newsletter_date_add` DATETIME NULL,
			`ip_registration_newsletter` varchar(15) NOT NULL,
			`http_referer` VARCHAR(255) NULL,
			`active` TINYINT(1) NOT NULL DEFAULT \'0\',
			PRIMARY KEY(`id`)
		) ENGINE='._MYSQL_ENGINE_.' default CHARSET=utf8'
          );
        return true;
    }

    public function postProcess()
    {
        $errors = array();
        $output = '';
        $table = '';
        /**/
        if (Tools::isSubmit('submitCustomize')) {
            $api = Tools::getValue('api');
            $DOPPLER_BTN_COLOR = Tools::getValue('DOPPLER_BTN_COLOR');
            $DOPPLER_TITLE_COLOR = Tools::getValue('DOPPLER_TITLE_COLOR');

            $profile = Tools::getValue('profile');
            if (!Validate::isInt($profile)) {
                $errors[] = $this->l('Invalid characters in profile');
            }
            $profile2 = Tools::getValue('profile2');
            /*if (!Validate::isInt($profile2)) {
                $errors[] = $this->l('Invalid characters in profile');
            }*/
            $key = Tools::getValue('key');
            if (!Validate::isEmail($key)) {
                $errors[] = $this->l('Invalid characters in key');
            }
            /*$key2 = Tools::getValue('key2');
            if (!Validate::isTplName($key2)) {
                $errors[] = $this->l('Invalid characters in key');
            }*/

            $DOPPLER_BOX_HEIGHT = Tools::getValue('DOPPLER_BOX_HEIGHT');
            if (!Validate::isInt($DOPPLER_BOX_HEIGHT)) {
                $errors[] = $this->l('Invalid value in height');
            }
            $DOPPLER_BOX_WIDTH = Tools::getValue('DOPPLER_BOX_WIDTH');
            if (!Validate::isInt($DOPPLER_BOX_WIDTH)) {
                $errors[] = $this->l('Invalid value in width');
            }
            $DOPPLER_SHOW_TIME = Tools::getValue('DOPPLER_SHOW_TIME');
            if (!Validate::isInt($DOPPLER_SHOW_TIME)) {
                $errors[] = $this->l('Invalid value in seconds');
            }
            $datec = Tools::getValue('datec');
            if (!Validate::isInt($datec)) {
                $errors[] = $this->l('Invalid date in date');
            }
            $dopplerpopup_img_link = Tools::getValue('dopplerpopup_img_link');
            if (!Validate::isUrl($dopplerpopup_img_link)) {
                if ($dopplerpopup_img_link == null) {
                } else {
                    $errors[] = $this->l('Invalid url');
                }
            }
            if (isset($errors) && count($errors) != '') {
                $output .= $this->displayError($errors);
            } else {
                Configuration::updateValue(
                    'dopplerpopup_img_link',
                    $dopplerpopup_img_link
                );
                Configuration::updateValue(
                    'DOPPLER_API',
                    $api
                );
                Configuration::updateValue(
                    'DOPPLER_BOX_HEIGHT',
                    $DOPPLER_BOX_HEIGHT
                );
                Configuration::updateValue(
                    'DOPPLER_SHOW_TIME',
                    $DOPPLER_SHOW_TIME
                );
                Configuration::updateValue(
                    'DOPPLER_BOX_WIDTH',
                    $DOPPLER_BOX_WIDTH
                );
                Configuration::updateValue(
                    'DOPPLER_KEY',
                    $key
                );
                Configuration::updateValue(
                    'DOPPLER_PROFILE',
                    $profile
                );
                /*Configuration::updateValue(
                    'DOPPLER_KEY2',
                    $key2
                );
                Configuration::updateValue(
                    'DOPPLER_PROFILE2',
                    $profile2
                );*/
                Configuration::updateValue(
                    'DOPPLER_DATEC',
                    $datec
                );
                Configuration::updateValue(
                    'DOPPLER_BTN_COLOR',
                    $DOPPLER_BTN_COLOR
                );
                Configuration::updateValue(
                    'DOPPLER_TITLE_COLOR',
                    $DOPPLER_TITLE_COLOR
                );
                $languages = Language::getLanguages(false);
                $default_language = (int)(Configuration::get('PS_LANG_DEFAULT'));
                $result = array();
                $result2 = array();
                foreach ($languages as $language) {
                    $result[$language['id_lang']] = Tools::getValue('titlel_'.$language['id_lang']);
                    $result2[$language['id_lang']] = Tools::getValue('descl_'.$language['id_lang']);
                }
                Configuration::updateValue(
                    'DOPPLER_TITLEL',
                    $result
                );
                Configuration::updateValue(
                    'DOPPLER_DESCL',
                    $result2
                );
                /* upload the image */
                if (isset($_FILES['body_dopplerpopup_img']) && isset($_FILES['body_dopplerpopup_img']['tmp_name']) && !empty($_FILES['body_dopplerpopup_img']['tmp_name'])) {
                    Configuration::set(
                        'PS_IMAGE_GENERATION_METHOD',
                        1
                    );
                    if (file_exists(
                        dirname(__FILE__).'/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg'
                    )) {
                        unlink(dirname(__FILE__).'/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg');
                    }
                    if ($error = ImageManager::validateUpload($_FILES['body_dopplerpopup_img'])) {
                        $errors .= $error;
                    } elseif (!($tmp_name = tempnam(_PS_TMP_IMG_DIR_, 'PS')) || !move_uploaded_file($_FILES['body_dopplerpopup_img']['tmp_name'], $tmp_name)) {
                        return false;
                    } elseif (!ImageManager::resize($tmp_name, dirname(__FILE__).'/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg')) {
                        $errors .= $this->displayError(
                            $this->l('An error occurred while attempting to upload the image.')
                        );
                    }
                    if (isset($tmp_name)) {
                        unlink($tmp_name);
                    }
                }
                if (file_exists(
                    dirname(__FILE__).'/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg'
                )) {
                    list($width, $height, $type, $attr) = getimagesize(
                        dirname(__FILE__).'/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg'
                    );
                    Configuration::updateValue(
                        'DOPPLER_IMAGE_WIDTH',
                        (int)round($width)
                    );
                    Configuration::updateValue(
                        'DOPPLER_IMAGE_HEIGHT',
                        (int)round($height)
                    );
                    Configuration::updateValue(
                        'DOPPLER_IMAGE_DISABLE',
                        0
                    );
                }
                ToolsCore::clearCache();
                $output .= $this->displayConfirmation($this->l('Settings updated.').'<br/>');
            }
        }
        return $output;
    }

    public function getConfigFieldsValues()
    {
        $fields_values = array(
            'api' => Tools::getValue(
                'api',
                Configuration::get('DOPPLER_API')
            ),
            'key' => Tools::getValue(
                'key',
                Configuration::get('DOPPLER_KEY')
            ),
            'profile' => Tools::getValue(
                'profile',
                Configuration::get('DOPPLER_PROFILE')
            ),
            'profile2' => Tools::getValue(
                'profile2',
                Configuration::get('DOPPLER_PROFILE2')
            ),
            'key2' => Tools::getValue(
                'key2',
                Configuration::get('DOPPLER_KEY2')
            ),
            'datec' => Tools::getValue(
                'datec',
                Configuration::get('DOPPLER_DATEC')
            ),
            'DOPPLER_EVERYWHERE' => Tools::getValue(
                'DOPPLER_EVERYWHERE',
                Configuration::get('DOPPLER_EVERYWHERE')
            ),
            'DOPPLER_BOX_HEIGHT' => Tools::getValue(
                'DOPPLER_BOX_HEIGHT',
                Configuration::get('DOPPLER_BOX_HEIGHT')
            ),
            'DOPPLER_BOX_WIDTH' => Tools::getValue(
                'DOPPLER_BOX_WIDTH',
                Configuration::get('DOPPLER_BOX_WIDTH')
            ),
            'DOPPLER_SHOW_TIME' => Tools::getValue(
                'DOPPLER_SHOW_TIME',
                Configuration::get('DOPPLER_SHOW_TIME')
            ),
            'DOPPLER_BTN_COLOR' => Tools::getValue(
                'DOPPLER_BTN_COLOR',
                Configuration::get('DOPPLER_BTN_COLOR')
            ),
            'DOPPLER_TITLE_COLOR' => Tools::getValue(
                'DOPPLER_TITLE_COLOR',
                Configuration::get('DOPPLER_TITLE_COLOR')
            ),
            'dopplerpopup_img_link' => Tools::getValue(
                'dopplerpopup_img_link',
                Configuration::get('dopplerpopup_img_link')
            ),
        );
        $languages = Language::getLanguages(false);
        foreach ($languages as $lang) {
            $fields_values['titlel'][$lang['id_lang']] = Tools::getValue(
                'titlel_',
                Configuration::get(
                    'DOPPLER_TITLEL',
                    $lang['id_lang']
                )
            );
            $fields_values['descl'][$lang['id_lang']] = Tools::getValue(
                'descl_',
                Configuration::get(
                    'DOPPLER_DESCL',
                    $lang['id_lang']
                )
            );
        }
        return $fields_values;
    }


    public function renderForm()
    {
        $this->bacimage = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg';
        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Configuration'),
                    'description' => $this->l('Configure Doppler'),
                    'icon' => 'icon-cogs'
                ),
                'input' => array(
                    array(
                        'type' => 'text',
                        'label' => $this->l('API'),
                        'name' => 'api',
                        'size' => 20,
                        'desc' => $this->l('Doppler API Key'),

                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Subscribers List ID'),
                        'name' => 'profile',
                        'size' => 20,
                        'desc' => $this->l('List ID to save contacts in Doppler'),

                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Doppler Email'),
                        'name' => 'key',
                        'size' => 20,
                        'desc' => $this->l('Your Doppler email to login'),

                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Popup Box Height in Pixels'),
                        'name' => 'DOPPLER_BOX_HEIGHT',
                        'size' => 33,
                        'suffix' => 'px',
                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Popup Box Width in Pixels'),
                        'name' => 'DOPPLER_BOX_WIDTH',
                        'size' => 33,
                        'suffix' => 'px',
                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Show PopUp After'),
                        'name' => 'DOPPLER_SHOW_TIME',
                        'size' => 33,
                        'suffix' => 'seconds',
                        'desc' => $this->l('Leave void to disable popup'),
                    ),
                    array(
                        'type' => 'color',
                        'label' => $this->l('Submit Button Color'),
                        'name' => 'DOPPLER_BTN_COLOR',
                        'size' => 33,
                    ),
                    array(
                        'type' => 'color',
                        'label' => $this->l('Title Color and Description'),
                        'name' => 'DOPPLER_TITLE_COLOR',
                        'size' => 33,
                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Popup Title'),
                        'name' => 'titlel',
                        'lang' => true,
                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Popup Description'),
                        'name' => 'descl',
                        'lang' => true,
                        /*'desc' => $this->l('Description for the popup'),*/
                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('Popup Link'),
                        'name' => 'dopplerpopup_img_link',
                        'size' => 33,
                    ),
                    array(
                        'type' => 'file',
                        'label' => $this->l('Popup Image'),
                        'name' => 'body_dopplerpopup_img',
                        'display_image' => true,
                        //'image' => $logo,
                        'thumb' => $this->context->link->protocol_content.$this->bacimage,
                    ),
                ),
                'submit' => array(
                    'title' => $this->l('Save'),
                )
            ),
        );
        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->table = $this->table;
        $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $lang->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_F||M_LANG') ? Configuration::get(
            'PS_BO_ALLOW_EMPLOYEE_F||M_LANG'
        ) : 0;
        $this->fields_form = array();
        $helper->identifier = $this->identifier;
        $helper->submit_action = 'submitCustomize';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
            'fields_value' => $this->getConfigFieldsValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id
        );
        return $helper->generateForm(array($fields_form));
    }

    public function hookdisplayTop($params)
    {
        if (Configuration::get('DOPPLER_SHOW_TIME') == null) {
            return false;
        }
        $curlInit = curl_init('http://api2.fromdoppler.com');
        curl_setopt($curlInit, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curlInit, CURLOPT_HEADER, true);
        curl_setopt($curlInit, CURLOPT_NOBODY, true);
        curl_setopt($curlInit, CURLOPT_RETURNTRANSFER, true);

        //get answer
        $response = curl_exec($curlInit);

        curl_close($curlInit);
        if ($response) {
        } else {
            //echo 'Doppler service down. Try later';
            return false;
        }
        $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
        $result = $dplClient->user->testApiConnection();
        $testConnection = $result->{'Client.TestApiConnectionResult'};
        $msg = '';
        if ($testConnection) {
            $msg = $this->l('OK');
        } else {
            //return false;
        }
        $titlel = Configuration::get(
            'DOPPLER_TITLEL',
            $this->context->language->id
        );
        $descl = Configuration::get(
            'DOPPLER_DESCL',
            $this->context->language->id
        );
        if (Tools::substr(Configuration::get('dopplerpopup_img_link'), 0, 4) == "http") {
            $source = Configuration::get('dopplerpopup_img_link');
        } else {
            $source = 'http://'.Configuration::get('dopplerpopup_img_link');
        }
        $this->smarty->assign(
            array(
                'titlel' => $titlel,
                'descl' => $descl,
                'psversion' => _PS_VERSION_,
                'dopplerpopup_img_link' => $source,
                'default_lang' => (int)$this->context->language->id,
                'dopplerpopup_cover' => Configuration::get('DOPPLER_IMAGE_COVER'),
                'dopplerpopup_width' => Configuration::get('DOPPLER_BOX_WIDTH'),
                'dopplerpopup_BOX_HEIGHT' => Configuration::get('DOPPLER_BOX_HEIGHT'),
                'dopplerpopup_SHOW_TIME' => Configuration::get('DOPPLER_SHOW_TIME'),
                'BTN_COLOR' => Configuration::get('DOPPLER_BTN_COLOR'),
                'TITLE_COLOR' => Configuration::get('DOPPLER_TITLE_COLOR'),
                'id_lang' => $this->context->language->id,
                'dopplerpopup_img' => !Configuration::get('DOPPLER_IMAGE_DISABLE') && file_exists('modules/dopplermail/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg'),
                'module_path' => $this->_path,
            )
        );
        return $this->display(
            __FILE__,
            'views/templates/front/dopplerpopup.tpl',
            $this->getCacheId()
        );
    }
    public function hookdisplayBeforeBodyClosingTag($params)
    {
        if (Configuration::get('DOPPLER_SHOW_TIME') == null) {
            return false;
        }
        $curlInit = curl_init('http://api2.fromdoppler.com');
        curl_setopt($curlInit, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curlInit, CURLOPT_HEADER, true);
        curl_setopt($curlInit, CURLOPT_NOBODY, true);
        curl_setopt($curlInit, CURLOPT_RETURNTRANSFER, true);

        //get answer
        $response = curl_exec($curlInit);

        curl_close($curlInit);
        if ($response) {
        } else {
            //echo 'Doppler service down. Try later';
            return false;
        }
        $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
        $result = $dplClient->user->testApiConnection();
        $testConnection = $result->{'Client.TestApiConnectionResult'};
        $msg = '';
        if ($testConnection) {
            $msg = $this->l('OK');
        } else {
            //return false;
        }
        $titlel = Configuration::get(
            'DOPPLER_TITLEL',
            $this->context->language->id
        );
        $descl = Configuration::get(
            'DOPPLER_DESCL',
            $this->context->language->id
        );
        $this->smarty->assign(
            array(
                'titlel' => $titlel,
                'descl' => $descl,
                'dopplerpopup_img_link' => Configuration::get('dopplerpopup_img_link'),
                'default_lang' => (int)$this->context->language->id,
                'dopplerpopup_cover' => Configuration::get('DOPPLER_IMAGE_COVER'),
                'dopplerpopup_width' => Configuration::get('DOPPLER_BOX_WIDTH'),
                'dopplerpopup_BOX_HEIGHT' => Configuration::get('DOPPLER_BOX_HEIGHT'),
                'dopplerpopup_SHOW_TIME' => Configuration::get('DOPPLER_SHOW_TIME'),
                'BTN_COLOR' => Configuration::get('DOPPLER_BTN_COLOR'),
                'TITLE_COLOR' => Configuration::get('DOPPLER_TITLE_COLOR'),
                'id_lang' => $this->context->language->id,
                'dopplerpopup_img' => !Configuration::get('DOPPLER_IMAGE_DISABLE') && file_exists('modules/dopplermail/views/img/dopplerpopup_img_'.(int)$this->context->shop->id.'.jpg'),
                'module_path' => $this->_path,
            )
        );
        return $this->display(
            __FILE__,
            'views/templates/front/dopplerpopup17.tpl',
            $this->getCacheId()
        );
    }
    public function hookDisplayHeader()
    {
        $this->context->controller->addCSS(
            ($this->_path).'views/css/dopplerpopup.css',
            'all'
        );
        $this->context->controller->addJS(($this->_path).'views/js/jquery.fan.js');
    }

    public function _displayInfo()
    {
        if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") {
            $sec = "https";
        } else {
            $sec = "http";
        }
        $curlInit = curl_init('http://api2.fromdoppler.com');
        curl_setopt($curlInit, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curlInit, CURLOPT_HEADER, true);
        curl_setopt($curlInit, CURLOPT_NOBODY, true);
        curl_setopt($curlInit, CURLOPT_RETURNTRANSFER, true);

        //get answer
        $response = curl_exec($curlInit);

        curl_close($curlInit);
        if ($response) {
        } else {
            //echo 'Doppler service down. Try later';
            return false;
        }
        $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
        $result = $dplClient->user->testApiConnection();
        $testConnection = $result->{'Client.TestApiConnectionResult'};
        $msg = '';
        if ($testConnection) {
            $msg = $this->l('Connection to Doppler OK');
        } else {
            $msg = $this->l('API error');
        }
        $this->context->smarty->assign(
            array(
                'msg' => $msg,
                'tok' => Tools::substr(
                    Tools::encrypt('dopplermail/cron'),
                    0,
                    10
                ),
                'idshop' => $this->context->shop->id,
                'iso_code' => $this->context->language->iso_code,
                'baseurl' => str_replace("http", $sec, _PS_BASE_URL_._MODULE_DIR_),
                'token' => Tools::substr(Tools::encrypt('dopplermail/cron'), 0, 10),
                'baseurl' => str_replace(
                    "http",
                    $sec,
                    _PS_BASE_URL_._MODULE_DIR_
                ),

            )
        );
        return $this->display(
            __FILE__,
            'views/templates/hook/infos.tpl'
        );
    }

    public function hookActionCustomerAccountAdd($params)
    {
        $email = $params['newCustomer']->email;
        $firstname = $params['newCustomer']->firstname;
        $lastname = $params['newCustomer']->lastname;
        $sql = 'SELECT `newsletter`
				FROM '._DB_PREFIX_.'customer
				WHERE `email` = \''.pSQL($email).'\'
				AND id_shop = '.pSQL((int)$this->context->shop->id);

        $res = Db::getInstance()
                 ->getRow($sql);
       
        if ($res != null) {
            $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
            //$result = $dplClient->user->testApiConnection();
            $result = $dplClient->subscriber->addSubscriber(
                array(
                    'SubscribersListID' => Configuration::get('DOPPLER_PROFILE'),
                    'EMail' => $email,
                    'FirstName' => $firstname,
                    'LastName' => $lastname
                )
            );
            $testConnection = $result->{'Subscriber.AddwithNameResult'};
        }
    }
    public function cron($params)
    {
        $res = Db::getInstance()
                 ->ExecuteS('SELECT *
				FROM '._DB_PREFIX_.'customer
				WHERE `newsletter` = 1
				AND id_shop = '.pSQL((int)$this->context->shop->id));

        if ($res != null) {
            $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
            foreach ($res as $re) {
                $result = $dplClient->subscriber->addSubscriber(
                    array(
                        'SubscribersListID' => Configuration::get('DOPPLER_PROFILE'),
                        'EMail' => $re['email'],
                        'FirstName' => $re['firstname'],
                        'LastName' => $re['lastname']
                    )
                );
                $testConnection = $result->{'Subscriber.AddwithNameResult'};
            }
        }
        if (Module::isInstalled('ps_emailsubscription') or Module::isInstalled('blocknewsletter')) {
                  $res = Db::getInstance()
                     ->ExecuteS('SELECT *
			    	FROM '._DB_PREFIX_.'newsletter
				    WHERE `active` = 1
				    AND id_shop = '.pSQL((int)$this->context->shop->id));
            if ($res != null) {
                $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
                //$result = $dplClient->user->testApiConnection();
                foreach ($res as $re) {
                    $result = $dplClient->subscriber->addSubscriber(
                        array(
                            'SubscribersListID' => Configuration::get('DOPPLER_PROFILE'),
                            'EMail' => $re['email'],
                            'FirstName' => 'none',
                            'LastName' => 'none'
                        )
                    );
                    $testConnection = $result->{'Subscriber.AddwithNameResult'};
                }
            }
        }
        echo 'Tus contactos han sido añadidos exitosamente / The contacts were added successfully';
    }

    public function _displayAdds()
    {
        $curlInit = curl_init('http://api2.fromdoppler.com');
        curl_setopt($curlInit, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curlInit, CURLOPT_HEADER, true);
        curl_setopt($curlInit, CURLOPT_NOBODY, true);
        curl_setopt($curlInit, CURLOPT_RETURNTRANSFER, true);

        //get answer
        $response = curl_exec($curlInit);

        curl_close($curlInit);
        if ($response) {
        } else {
            //echo 'Doppler service down. Try later';
            return false;
        }
        $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
        $result = $dplClient->user->testApiConnection();
        $testConnection = $result->{'Client.TestApiConnectionResult'};
        $msg = '';
        if (!$testConnection) {
            return false;
        }
        $dplClient = new DopplerClient(Configuration::get('DOPPLER_API'));
        $result = $dplClient->user->getSubscribersLists();
        $testConnection = $result->{'Client.GetSubscribersListsResult'};
        if (isset($testConnection->subscriberslist->SubscribersListID) && $testConnection->subscriberslist->SubscribersListID) {
            $this->context->smarty->assign(array('testConnection' => $testConnection));
            return $this->display(
                __FILE__,
                'views/templates/hook/adds2.tpl'
            );
        }
        if (isset($testConnection->subscriberslist) && $testConnection->subscriberslist) {
            $this->context->smarty->assign(array('testConnection' => $testConnection->subscriberslist));
            return $this->display(
                __FILE__,
                'views/templates/hook/adds2.tpl'
            );
        }
    }

    public function getContent()
    {
        $errors = '';
        return $this->postProcess().$this->_displayInfo().$this->renderForm().$this->_displayAdds();
    }
}
