{*
* 2007-2014 PrestaShop
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2019 PrestaShop SA
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*}
    {literal}
<style type="text/css">
	@import url(http://fonts.googleapis.com/css?family=Roboto+Condensed:400,300,700);
	#parallax-wrapper{
		position:relative;
		min-height:250px;
		width:100%;
		text-align: center;
	}
	.img-holder
	{
		padding-top: 10px;
		padding-bottom: 10px;
		position:relative;
		text-align: center;
	}
	#modulesden_popup{
        background: url("{/literal}{$module_dir}views/img/{$dopplerpopup_cover}{literal}") center center no-repeat;
		min-width: {$dopplerpopup_width}px;
		min-height: {$dopplerpopup_BOX_HEIGHT}px;
		padding: 15px 18px;
		background-size: 100% 100%;
	}
	.fancybox-skin{
		-webkit-border-radius: 0px;
		-moz-border-radius: 0px;
		border-radius: 0px;
	}
	.modulesden-newsletter{
		max-width: 400px;
	}
	.modulesden-newsletter .modulesden-email {
		height: 50px;
		line-height: 50px;
		width: 100%;
		color: #c8c8c8;
		font-size: 100.67%;
		border: none;
		padding-top: 0px;
		padding-bottom: 0px;
		padding-left: 10px;
		max-width: 260px;
	}
	.modulesden-newsletter label{
		font-family: 'Roboto Condensed', sans-serif;
		font-weight: 300;
		margin-bottom: 12px;
		color: white;
	}
	.modulesden-newsletter h2 {
		margin-top: 50px;
		font-weight: 300;
		text-transform: uppercase;
		font-family: 'Roboto Condensed', sans-serif;
		color: #BD1E30;
		font-size: 35px;
		font-weight: bold;
		color: white;
	}
	.modulesden-newsletter h3 {
		font-size: 166.67%;
		font-weight: 300;
		text-transform: uppercase;
		font-family: 'Roboto Condensed', sans-serif;
		color: white;
	}
    .dtc{color:{/literal}{$TITLE_COLOR}{literal}!important}
	.modulesden-btn-newsletter{
		background: {/literal}{$BTN_COLOR}{literal};
		color: white;
		border: none;
		font-family: 'Roboto Condensed', sans-serif;
		font-size: 16px;
		padding: 13px;
		-webkit-border-radius: 3px;
		-moz-border-radius: 3px;
		-o-border-radius: 3px;
		-ms-border-radius: 3px;
		border-radius: 3px;
		-webkit-transition: .5s;
		-moz-transition: .4s;
		-o-transition: .5s;
		-ms-transition: .5s;
		transition: .5s;
		margin-top: 10px;
		display: block;
	}	
	

</style>
{/literal}
<div style="display: none;">
<div id="modulesden_popup" style="">
				<div class="modulesden-newsletter">
					<form action="{$module_dir}" method="POST">
						<a href="{$dopplerpopup_img_link}"><h2 class="dtc">{$titlel}</h2></a>
						
						<label for="newsletter" class="dtc">{$descl}</label><br/>
						<input type="text" name="email" title="{l s='signup' mod='dopplermail'}" class="modulesden-email" placeholder="{l s='Enter your email' mod='dopplermail'}">
						<button class="modulesden-btn-newsletter" name="submitNewsletter" type="submit" title="{l s='Submit' mod='dopplermail'}">
							<span><span>{l s='Submit' mod='dopplermail'} </span> </span>
						</button>
						<input type="hidden" name="action" value="0">
					</form>
				</div>
			</div>
</div>
{if $psversion < "1.7.0.0"}
<script>
$(document).ready(function () {
	
	if(getCookie_popup("dopplerPopupCookie") != 1){
		$('html').append('<a class="fancybox" style="display:none" href="#modulesden_popup"></a>');
		setTimeout(function(){
			$('.fancybox').fancybox({
				padding: 0,
    width:{$dopplerpopup_width},
    height:{$dopplerpopup_BOX_HEIGHT},
    'autoSize' : false,
				afterClose: function () {
    cookieSession_popup();
					$('a[href="#modulesden_popup"]').remove();
				}
			});
			$('a[href="#modulesden_popup"]').trigger('click');
		},{$dopplerpopup_SHOW_TIME} * 1000);
	}
    
	
	$('.modulesden-btn-newsletter').on('click',function(){
		//$('.modulesden-btn-newsletter').module_path
		$.ajax({
			method: "POST",
			url: "{$module_path}subscribe.php",
			data: { action: 0, email: $('.modulesden-email').val(), }
		})
		  .done(function( msg ) {
			var obj = $.parseJSON(msg);
			if(obj.code != 1){
				if(obj.message){
					$('.modulesden-email').val(obj.message);
				}
				$('.modulesden-email').css('background-color', 'red');
				
			}else{
				if(obj.message){
					$('.modulesden-email').val(obj.message);
				}
				cookieSession_popup();
				$.fancybox.close();
			};
		});
		return false;
	})
	

	
	function cookieSession_popup() {
			var session_name = 'dopplerPopupCookie';
			var session_val = '1';
			var expire_date = new Date();
			expire_date.setMonth(expire_date.getMonth()+3);
			document.cookie = session_name + "=" + escape(session_val) +";path=/;" + ((expire_date==null)?"" : ("; expires=" + expire_date.toGMTString()))
		}
		
	function getCookie_popup(cname) {
		var name = cname + "=";
		var ca = document.cookie.split(';');
		for(var i=0; i<ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1);
			if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
		}
		return "";
	}
});
</script>
	{/if}
